// CopyResult.cpp : t@C
//

#include "stdafx.h"
#include "mtpvc.h"
#include "CopyResult.h"
#include "afxdialogex.h"

enum {
	itemSrc,
	itemDst,
	itemResult,
	itemError,
};


// CCopyResult _CAO

IMPLEMENT_DYNAMIC(CCopyResult, CDialogEx)

CCopyResult::CCopyResult(CWnd* pParent /*=NULL*/)
	: CDialogEx(CCopyResult::IDD, pParent)
{

}

CCopyResult::~CCopyResult()
{
}

void CCopyResult::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_RESULT, m_list_result);
}


BEGIN_MESSAGE_MAP(CCopyResult, CDialogEx)
END_MESSAGE_MAP()


// CCopyResult bZ[W nh[
void CCopyResult::AddResult(CString src, CString dst, int result, int error)
{
	COPY_RESULT_DATA data;

	data.src = src;
	data.dst = dst;
	data.result = result;
	data.error = error;
	m_result.push_back(data);
}

CString CCopyResult::GetErrorMessage(int error)
{
	TCHAR text[MAX_PATH];
	if(FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, error, 0, text, sizeof(text) / sizeof(TCHAR), NULL)) {
		return text;
	}
	return _T("");
}

BOOL CCopyResult::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	CRect rc;
	m_list_result.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_LABELTIP);
	m_list_result.GetClientRect(rc);
	int wide = (rc.right - rc.left - ::GetSystemMetrics(SM_CXVSCROLL) - ::GetSystemMetrics(SM_CXEDGE) * 2) / 9;
	m_list_result.InsertColumn(itemSrc, _T("Rs["), LVCFMT_LEFT, wide * 3);
	m_list_result.InsertColumn(itemDst, _T("Rs["), LVCFMT_LEFT, wide * 3);
	m_list_result.InsertColumn(itemResult, _T(""), LVCFMT_LEFT, wide);
	m_list_result.InsertColumn(itemError, _T("G["), LVCFMT_LEFT, wide * 2);

	int count = 0;
	for(std::vector<COPY_RESULT_DATA>::iterator crd = m_result.begin() ; crd != m_result.end() ; ++crd) {
		m_list_result.InsertItem(count, crd->src);
		m_list_result.SetItemText(count, itemDst, crd->dst);
		m_list_result.SetItemText(count, itemResult, crd->result ? _T("") : _T("s"));
		if(!crd->result) {
			m_list_result.SetItemText(count, itemError, GetErrorMessage(crd->error));
		}
		count++;
	}
	return TRUE;
}
