#include "stdafx.h"
#include "nMtpFileFind.h"

/**
 *	RXgN^
 */
CNMtpFileFind::CNMtpFileFind()
{
	handle = INVALID_HANDLE_VALUE;
	find_data = NULL;
	next_data = NULL;
}

/**
 *	fXgN^
 */
CNMtpFileFind::~CNMtpFileFind()
{
	Close();
}

/**
 *	I
 */
void CNMtpFileFind::Close()
{
	if(find_data) {
		delete find_data;
		find_data = NULL;
	}
	if(next_data) {
		delete next_data;
		next_data = NULL;
	}
	root_path.Empty();
	if(handle != INVALID_HANDLE_VALUE) {
		NMtpFindClose(handle);
		handle = INVALID_HANDLE_VALUE;
	}
}

/**
 *	t@C
 *	@param pstrName pX
 *	@param dwUnused gp
 *	@return 
 */
BOOL CNMtpFileFind::FindFile(LPCWSTR pstrName, DWORD dwUnused)
{
	UNUSED_ALWAYS(dwUnused);
	Close();

	handle = INVALID_HANDLE_VALUE;
	if(pstrName == NULL) {
		pstrName = L"*";
	}
	next_data = new(std::nothrow) WIN32_FIND_DATA;
	if(next_data) {
		handle = NMtpFindFirstFile(pstrName, next_data);
		if(handle == INVALID_HANDLE_VALUE) {
			Close();
			return FALSE;
		}
		TCHAR root[MAX_PATH];
		TCHAR drive[_MAX_DRIVE], dir[_MAX_DIR];
		if(pstrName[0] == L'\\' || pstrName[0] == L'.' || pstrName[0] == L'*' || pstrName[0] == L'?' || pstrName[1] == L':') {
			if(_tfullpath(root, pstrName, MAX_PATH)) {
				_tsplitpath_s(root, drive, _MAX_DRIVE, dir, _MAX_DIR, NULL, 0, NULL, 0);
				_tmakepath_s(root, MAX_PATH, drive, dir, NULL, NULL);
				root_path = root;
				return TRUE;
			}
		} else {
			_tsplitpath_s(pstrName, NULL, 0, dir, _MAX_DIR, NULL, 0, NULL, 0);
			_tmakepath_s(root, MAX_PATH, NULL, dir, NULL, NULL);
			root_path = root;
			return TRUE;
		}
		Close();
	}
	return FALSE;
}

/**
 *	̌ʎ擾
 *	@return 擾
 */
BOOL CNMtpFileFind::FindNextFile()
{
	if(handle != INVALID_HANDLE_VALUE) {
		if(!find_data) {
			find_data = new(std::nothrow) WIN32_FIND_DATA;
		}
		if(find_data) {
			WIN32_FIND_DATA *swap_data = find_data;
			find_data = next_data;
			next_data = swap_data;
			return NMtpFindNextFile(handle, next_data);
		}
	}
	return FALSE;
}

/**
 *	`FbN
 *	@param dwMask }XNl
 *	@return 0 ȊOŎw葮L
 */
BOOL CNMtpFileFind::MatchesMask(DWORD dwMask) const
{
	if(find_data) {
		return find_data->dwFileAttributes & dwMask;
	}
	return FALSE;
}

/**
 *	[hI[`FbN
 *	@return 0 ȊOŃ[hI[L
 */
BOOL CNMtpFileFind::IsReadOnly() const
{
	return MatchesMask(FILE_ATTRIBUTE_READONLY);
}

/**
 *	fBNg`FbN
 *	@return 0 ȊOŃfBNgL
 */
BOOL CNMtpFileFind::IsDirectory() const {
	return MatchesMask(FILE_ATTRIBUTE_DIRECTORY);
}

/**
 *	k`FbN
 *	@return 0 ȊOňkL
 */
BOOL CNMtpFileFind::IsCompressed() const {
	return MatchesMask(FILE_ATTRIBUTE_COMPRESSED);
}

/**
 *	VXe`FbN
 *	@return 0 ȊOŃVXeL
 */
BOOL CNMtpFileFind::IsSystem() const {
	return MatchesMask(FILE_ATTRIBUTE_SYSTEM);
}

/**
 *	Bt@C`FbN
 *	@return 0 ȊOŉBt@CL
 */
BOOL CNMtpFileFind::IsHidden() const {
	return MatchesMask(FILE_ATTRIBUTE_HIDDEN);
}

/**
 *	ꎞt@C`FbN
 *	@return 0 ȊOňꎞt@CL
 */
BOOL CNMtpFileFind::IsTemporary() const {
	return MatchesMask(FILE_ATTRIBUTE_TEMPORARY);
}

/**
 *	W`FbN
 *	@return 0 ȊOŕWL
 */
BOOL CNMtpFileFind::IsNormal() const {
	return MatchesMask(FILE_ATTRIBUTE_NORMAL);
}

/**
 *	A[JCu`FbN
 *	MTP foCX̏ꍇA[JCu͕tȂ
 *	@return 0 ȊOŃA[JCuL
 */
BOOL CNMtpFileFind::IsArchived() const {
	return MatchesMask(FILE_ATTRIBUTE_ARCHIVE);
}

/**
 *	. or .. tH_
 *	@return 0 ȊO . or .. tH_
 */
BOOL CNMtpFileFind::IsDots() const
{
	BOOL result = FALSE;
	if(find_data && IsDirectory()) {
		if(find_data->cFileName[0] == L'.') {
			if(find_data->cFileName[1] == L'\0' || (find_data->cFileName[1] == L'.' && find_data->cFileName[2] == L'\0')) {
				result = TRUE;
			}
		}
	}
	return result;
}

/**
 *	ŏIANZX擾
 *	MTP foCX̏ꍇl͐Ȃ
 *	@param pTimeStamp ŏIANZXi[\̃|C^
 *	@return TRUE Ŏ擾
 */
BOOL CNMtpFileFind::GetLastAccessTime(FILETIME *pTimeStamp) const
{
	if(find_data && pTimeStamp) {
		*pTimeStamp = find_data->ftLastAccessTime;
		return TRUE;
	}
	return FALSE;
}

/**
 *	ŏIXV擾
 *	@param pTimeStamp ŏIXVi[\̃|C^
 *	@return TRUE Ŏ擾
 */
BOOL CNMtpFileFind::GetLastWriteTime(FILETIME *pTimeStamp) const
{
	if(find_data && pTimeStamp) {
		*pTimeStamp = find_data->ftLastWriteTime;
		return TRUE;
	}
	return FALSE;
}

/**
 *	쐬擾
 *	@param pTimeStamp 쐬i[\̃|C^
 *	@return TRUE Ŏ擾
 */
BOOL CNMtpFileFind::GetCreationTime(FILETIME *pTimeStamp) const
{
	if(find_data && pTimeStamp) {
		*pTimeStamp = find_data->ftCreationTime;
		return TRUE;
	}
	return FALSE;
}

/**
 *	ŏIANZX擾
 *	MTP foCX̏ꍇl͐Ȃ
 *	@param refTime ŏIANZXi[NX
 *	@return TRUE Ŏ擾
 */
BOOL CNMtpFileFind::GetLastAccessTime(CTime &refTime) const
{
	if(find_data) {
		if(CTime::IsValidFILETIME(find_data->ftLastAccessTime)) {
			refTime = CTime(find_data->ftLastAccessTime);
		} else {
			refTime = CTime();
		}
		return TRUE;
	}
	return FALSE;
}

/**
 *	ŏIXV擾
 *	@param refTime ŏIXVi[NX
 *	@return TRUE Ŏ擾
 */
BOOL CNMtpFileFind::GetLastWriteTime(CTime &refTime) const
{
	if(find_data) {
		if (CTime::IsValidFILETIME(find_data->ftLastWriteTime)) {
			refTime = CTime(find_data->ftLastWriteTime);
		} else {
			refTime = CTime();
		}
		return TRUE;
	}
	return FALSE;
}

/**
 *	쐬擾
 *	@param refTime 쐬i[NX
 *	@return TRUE Ŏ擾
 */
BOOL CNMtpFileFind::GetCreationTime(CTime &refTime) const
{
	if(find_data) {
		if (CTime::IsValidFILETIME(find_data->ftCreationTime)) {
			refTime = CTime(find_data->ftCreationTime);
		} else {
			refTime = CTime();
		}
		return TRUE;
	}
	return FALSE;
}

/**
 *	t@CTCY擾
 *	@return t@CTCY
 */
ULONGLONG CNMtpFileFind::GetLength() const
{
	ULARGE_INTEGER size;

	if(find_data) {
		size.LowPart = find_data->nFileSizeLow;
		size.HighPart = find_data->nFileSizeHigh;
	} else {
		size.QuadPart = 0;
	}
	return size.QuadPart;
}

/**
 *	t@C擾
 *	@return t@C
 */
CString CNMtpFileFind::GetFileName() const
{
	CString name;
	if(find_data) {
		name = find_data->cFileName;
	}
	return name;
}

/**
 *	t@CtpX擾
 *	@return t@CtpX
 */
CString CNMtpFileFind::GetFilePath() const
{
	if(root_path.Right(1) == L"\\") {
		return root_path + GetFileName();
	}
	return root_path + L"\\" + GetFileName();
}

/**
 *	t@C^Cg擾
 *	@return t@C^Cg
 */
CString CNMtpFileFind::GetFileTitle() const
{
	CString fname;

	_tsplitpath_s(GetFileName(), NULL, 0, NULL, 0, fname.GetBuffer(_MAX_FNAME), _MAX_FNAME, NULL, 0);
	fname.ReleaseBuffer();

	return fname;
}

/**
 *	t@Cgq擾
 *	@return t@Cgq
 */
CString CNMtpFileFind::GetFileExt() const
{
	CString ext;

	_tsplitpath_s(GetFileName(), NULL, 0, NULL, 0, NULL, 0, ext.GetBuffer(_MAX_EXT), _MAX_EXT);
	ext.ReleaseBuffer();

	return ext;
}

/**
 *	[gtH_擾
 *	MTP foCX̏ꍇl͐Ȃ
 *	@return [gtH_
 */
CString CNMtpFileFind::GetRoot() const
{
	return root_path;
}

/**
 *	URL 擾
 *	MTP foCX̏ꍇl͐Ȃ
 *	@return URL
 */
CString CNMtpFileFind::GetFileURL() const
{
	CString url = L"file://" + GetFilePath();
	return url;
}

/**
 *	t@C擾
 *	@param lpszFileName t@CpX
 *	@param rStatus t@Ci[NX
 *	@return TRUE Ŏ擾
 */
BOOL CNMtpFileFind::GetStatus(LPCTSTR lpszFileName, CFileStatus &rStatus)
{
	BOOL result = FALSE;

	if(lpszFileName)  {
		WIN32_FIND_DATA fd;

		if(NMtpGetStatus(lpszFileName, &fd)) {
			rStatus.m_attribute = (BYTE)(fd.dwFileAttributes & ~FILE_ATTRIBUTE_NORMAL);
			rStatus.m_size = ((ULONGLONG)fd.nFileSizeHigh << 32) | fd.nFileSizeLow;

			if(CTime::IsValidFILETIME(fd.ftCreationTime)) {
				rStatus.m_ctime = CTime(fd.ftCreationTime);
			} else {
				rStatus.m_ctime = CTime();
			}
			if (CTime::IsValidFILETIME(fd.ftLastAccessTime)) {
				rStatus.m_atime = CTime(fd.ftLastAccessTime);
			} else {
				rStatus.m_atime = CTime();
			}
			if(CTime::IsValidFILETIME(fd.ftLastWriteTime)) {
				rStatus.m_mtime = CTime(fd.ftLastWriteTime);
			} else {
				rStatus.m_mtime = CTime();
			}
			if(rStatus.m_ctime.GetTime() == 0) {
				rStatus.m_ctime = rStatus.m_mtime;
			}
			if(rStatus.m_atime.GetTime() == 0) {
				rStatus.m_atime = rStatus.m_mtime;
			}
			result = TRUE;
		}
	}
	return result;
}

IMPLEMENT_DYNAMIC(CNMtpFileFind, CObject)

